## expat 2.2.5

=== debian/changelog ===
expat (2.2.5-3ubuntu0.9) bionic-security; urgency=medium

  * SECURITY REGRESSION: Tests failed
    - debian/patches/CVE-2022-43680-1.patch: backport patch
      to work for this version in expat/tests/runtests.c.

 -- David Fernandez Gonzalez <david.fernandezgonzalez@canonical.com>  Fri, 18 Nov 2022 11:57:30 +0100

expat (2.2.5-3ubuntu0.8) bionic-security; urgency=medium

  * SECURITY UPDATE: use-after-free
    - debian/patches/CVE-2022-40674.patch: adds a conditional call to
      storeRawNames() in func internalEntityProcessor following a call
      to doCOntent() that could result in unbalanced tags upon returning.
    - CVE-2022-40674
  * SECURITY UPDATE: use-after-free
    - debian/patches/CVE-2022-43680-1.patch: adds tests to cover
      DTD destruction in XML_ExternalEntityParserCreate in
      expat/tests/runtests.c.
    - debian/patches/CVE-2022-43680-2.patch: fix overeager DTD
      destruction in XML_ExternalEntityParserCreate in
      expat/lib/xmlparse.c.
    - CVE-2022-43680

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Tue, 08 Nov 2022 07:13:44 -0300

expat (2.2.5-3ubuntu0.7) bionic-security; urgency=medium

  * SECURITY UPDATE: Stack exhaustion
    - debian/patches/CVE-2022-25313.patch: prevent
      stack exhaustion in build_model in expat/lib/xmlparse.c.
    - debian/patches/fix-build_model-regression.patch: fix build_model
      regression in expat/lib/xmlparse.c.
    - CVE-2022-25313
  * SECURITY UPDATE: Integer overflow
    - debian/patches/CVE-2022-25314.patch: prevent integer overflow in
      copyString in expat/lib/xmlparse.c.
    - CVE-2022-25314
  * SECURITY UPDATE: Integer overflow
    - debian/patches/CVE-2022-25315.patch: prevent integer overflow in
      storeRawNames in expat/lib/xmlparse.c.
    - CVE-2022-25315
  * SECURITY UPDATE: relax fix to CVE-2022-25236 with regard to
    RFC 3986 URI characters and possibly regressions
    - debian/patches/CVE-2022-25236-3.patch: add a note on namespace URI
      validation in expat/doc/reference.html, expat/lib/expat.h.
    - debian/patches/CVE-2022-25236-4.patch: document namespace separator
      effect right in header expat/lib/expat.h.
    - debian/patches/CVE-2022-25236-5.patch: cover relaxed fix in tests.
    - debian/patches/CVE-2022-25236-6.patch: relax fix with regard to
      RFC 3986 URI characters in expat/lib/xmlparse.c. (LP: #1963903)

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Tue, 08 Mar 2022 09:28:37 -0300

expat (2.2.5-3ubuntu0.4) bionic-security; urgency=medium

  * SECURITY UPDATE: Realloc misbehavior
    - debian/patches/CVE-2021-45960.patch: detect and prevent troublesome
      left shifts in function storeAtts in expat/lib/xmlparse.c.
    - CVE-2021-45960
  * SECURITY UPDATE: Integer overflow
    - debian/patches/CVE-2021-46143.patch: prevent integer overflow
      on m_groupSize in function doProlog in expat/lib/xmlparse.c.
    - CVE-2021-46143
  * SECURITY UPDATE: Integer overflow
    - debian/patches/CVE-2022-22822-to-CVE-2022-22827.patch: prevent integer overflow
      in multiple places in expat/lib/xmlparse.c.
    - CVE-2022-22822
    - CVE-2022-22823
    - CVE-2022-22824
    - CVE-2022-22825
    - CVE-2022-22826
    - CVE-2022-22827
  * SECURITY UPDATE: Signed integer overflow
    - debian/patches/CVE-2022-23852-*.patch: detect and prevent
      integer overflow in XML_GetBuffer in expat/lib/xmlparse.c and
      adds test to cover it in expat/tests/runtests.c.
    - CVE-2022-23852
  * SECURITY UPDATE: Integer overflow
    - debian/patches/CVE-2022-23990.patch: prevent integer overflow in
      doProlog in expat/lib/xmlparse.c.
    - CVE-2022-23990
  * SECURITY UPDATE: Incomplete validation encoding
    - debian/patches/CVE-2022-25235-*.patch: adds missing validation
      and adds tests in expat/lib/xmltok_impl.c, expat/tests/runtests.c.
    - CVE-2022-25235
  * SECURITY UPDATE: Namespace-separator insertions
    - debian/patches/CVE-2022-25236-*.patch: Protect against malicious
      namespace declarations in expat/lib/xmlparse.c, expat/tests/runtests.c.
    - CVE-2022-25236

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Thu, 17 Feb 2022 20:38:16 -0300

expat (2.2.5-3ubuntu0.2) bionic-security; urgency=medium

  * SECURITY UPDATE: heap-based buffer over-read
    - debian/patches/CVE-2019-15903.patch: Deny internal
      entities closing the doctype in expat/lib/xmlparse.c.
    - CVE-2019-15903

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Tue, 10 Sep 2019 15:05:44 -0300

expat (2.2.5-3ubuntu0.1) bionic-security; urgency=medium

  * SECURITY UPDATE: Denial of service
    - debian/patches/CVE-2018-20843.patch: adds a break in
      setElementTypePrefix avoiding consume a high amount of RAM
      and CPU in expat/lib/xmlparser.c
    - CVE-2018-20843

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Wed, 26 Jun 2019 12:14:29 -0300

expat (2.2.5-3) unstable; urgency=medium

  * Don't install irrelevant README.md (closes: #884818).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 20 Dec 2017 00:17:04 +0000

expat (2.2.5-2) unstable; urgency=medium

  * Upload to Sid.
  * Install AUTHORS file.
  * Update project homepage.
  * Migrate d/copyright to format 1.0 .
  * Update debhelper level to 11 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 17 Dec 2017 07:33:25 +0000

expat (2.2.5-1) experimental; urgency=medium

  * New upstream release (closes: #883708).
  * Use the main source for packaging (closes: #874177).
  * Drop outdated multilib packages (closes: #775942, #779459).
  * Add docbook2x build dependency.
  * Update libexpat1 symbols.
  * Update Standards-Version to 4.1.2 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 16 Dec 2017 07:24:56 +0000

expat (2.2.3-2) unstable; urgency=medium

  * Do not install .la files (closes: #880110).
  * Don't expose libbsd-dev dependency on libexpat1-dev .
  * Update Standards-Version to 4.1.1:
    - change libexpat1-udeb priority to optional.



=== debian/control ===
Source: expat
Section: text
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Standards-Version: 4.1.2
Build-Depends: debhelper (>= 11), docbook-to-man, docbook2x,
 libbsd-dev [kfreebsd-amd64 kfreebsd-i386 hurd-i386]
Homepage: https://libexpat.github.io/
Vcs-Browser: http://svn.debian.org/wsvn/debian-xml-sgml/packages/expat/trunk/
Vcs-Svn: svn://svn.debian.org/svn/debian-xml-sgml/packages/expat/trunk/

Package: libexpat1-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Provides: libexpat-dev
Conflicts: libexpat-dev
Depends: ${misc:Depends}, libexpat1 (= ${binary:Version}), libc6-dev | libc-dev
Description: XML parsing C library - development kit
 This package contains the header file and development libraries of
 expat, the C library for parsing XML.  Expat is a stream oriented XML
 parser.  This means that you register handlers with the parser prior
 to starting the parse.  These handlers are called when the parser
 discovers the associated structures in the document being parsed.  A
 start tag is an example of the kind of structures for which you may
 register handlers.

Package: libexpat1
Section: libs
Architecture: any
Conflicts: wink (<= 1.5.1060-4)
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Description: XML parsing C library - runtime library
 This package contains the runtime, shared library of expat, the C
 library for parsing XML. Expat is a stream-oriented parser in
 which an application registers handlers for things the parser
 might find in the XML document (like start tags).

Package: libexpat1-udeb
XC-Package-Type: udeb
Section: debian-installer
Priority: optional
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: XML parsing C library - runtime library
 This package contains the runtime, shared library of expat, the C
 library for parsing XML.

Package: expat
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: XML parsing C library - example application
 This package contains xmlwf, an example application of expat, the C
 library for parsing XML.  The arguments to xmlwf are one or more
 files which are each to be checked for XML well-formedness.

## expat 2.2.6

=== debian/changelog ===
expat (2.2.6-2+deb10u7) buster-security; urgency=medium

  * Non-maintainer upload by the LTS Team.
  * Fix test suite.
  * Backporting patch for CVE-2023-52425 - DoS (resource consumption)
    parsing really big tokens due to O(n²) complexity. Closes: #1063238)

 -- Tobias Frost <tobi@debian.org>  Sat, 06 Apr 2024 18:16:16 +0200

expat (2.2.6-2+deb10u6) buster-security; urgency=high

  * Non-maintainer upload by the LTS Team.
  * Add patch to fix heap use-after-free after overeager destruction
    of a shared DTD in function XML_ExternalEntityParserCreate in
    out-of-memory situations. (Fixes: CVE-2022-43680) (Closes: #1022743)

 -- Utkarsh Gupta <utkarsh@debian.org>  Fri, 28 Oct 2022 02:57:28 +0530

expat (2.2.6-2+deb10u5) buster-security; urgency=high

  * Non-maintainer upload by the LTS Team.
  * CVE-2022-40674
    heap use-after-free issue in doContent()
    (based on the backport for Bullseye made by Laszlo Boszormenyi)
  * update test-* patches to be able to run testsuite
  * debian/rules: add run of testsuite
                  (but leave it deactivated as I only tested on amd64)

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 24 Sep 2022 11:03:02 +0200

expat (2.2.6-2+deb10u4) buster-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * lib: Relax fix to CVE-2022-25236 with regard to RFC 3986 URI characters
  * tests: Cover relaxed fix to CVE-2022-25236
  * lib: Document namespace separator effect right in header <expat.h>
  * lib|doc: Add a note on namespace URI validation

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 10 Mar 2022 22:02:18 +0100

expat (2.2.6-2+deb10u3) buster-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Prevent stack exhaustion in build_model (CVE-2022-25313)
  * Prevent integer overflow in storeRawNames (CVE-2022-25315)
  * Prevent integer overflow in copyString (CVE-2022-25314)
  * lib: Fix (harmless) use of uninitialized memory
  * lib: Protect against malicious namespace declarations (CVE-2022-25236)
    (Closes: #1005895)
  * tests: Cover CVE-2022-25236
  * lib: Drop unused macro UTF8_GET_NAMING
  * lib: Add missing validation of encoding (CVE-2022-25235)
    (Closes: #1005894)
  * tests: Cover missing validation of encoding (CVE-2022-25235)
  * Fix build_model regression.
  * tests: Protect against nested element declaration model regressions

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 20 Feb 2022 17:19:40 +0100

expat (2.2.6-2+deb10u2) buster-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * lib: Detect and prevent troublesome left shifts in function storeAtts
    (CVE-2021-45960) (Closes: #1002994)
  * lib: Prevent integer overflow on m_groupSize in function doProlog
    (CVE-2021-46143)
  * lib: Prevent integer overflow at multiple places (CVE-2022-22822,
    CVE-2022-22823, CVE-2022-22824, CVE-2022-22825, CVE-2022-22826,
    CVE-2022-22827) (Closes: #1003474)
  * lib: Detect and prevent integer overflow in XML_GetBuffer (CVE-2022-23852)
  * lib: Prevent integer overflow in doProlog (CVE-2022-23990)

 -- Salvatore Bonaccorso <carnil@debian.org>  Wed, 09 Feb 2022 15:18:06 +0100

expat (2.2.6-2+deb10u1) buster-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * xmlparse.c: Deny internal entities closing the doctype (CVE-2019-15903)
    (Closes: #939394)

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 19 Sep 2019 23:13:41 +0200

expat (2.2.6-2) unstable; urgency=high

  * Fix extraction of namespace prefix from XML name (CVE-2018-20843)
    (closes: #931031).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 24 Jun 2019 21:18:31 +0000

expat (2.2.6-1) unstable; urgency=medium

  * New upstream release.
  * Disable Vcs-* fields for now.
  * Update Standards-Version to 4.1.5 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 15 Aug 2018 15:18:15 +0000

=== debian/rules ===
#!/usr/bin/make -f
## ----------------------------------------------------------------------
## debian/rules : package script for expat
## ----------------------------------------------------------------------

## uncomment this to turn on verbose mode
#export DH_VERBOSE=1

DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS   ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
	CONFFLAGS = --build=$(DEB_HOST_GNU_TYPE)
else
	CONFFLAGS = --build=$(DEB_BUILD_GNU_TYPE) --host=$(DEB_HOST_GNU_TYPE)
endif

ifneq (,$(filter $(DEB_HOST_ARCH_OS), kfreebsd hurd))
	CONFFLAGS += --with-libbsd
endif

# -pthread -D_REENTRANT #551079
CFLAGS  = `dpkg-buildflags --get CFLAGS`
CFLAGS  += -Wall

LDFLAGS = -Wl,-Bsymbolic-functions
LDFLAGS += `dpkg-buildflags --get LDFLAGS`

CPPFLAGS = `dpkg-buildflags --get CPPFLAGS`

UPACKAGE = $(shell dh_listpackages | grep -- -udeb$$)

COMMA = ,
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

config-common-stamp:
	dh_testdir
	rm -rf $(CURDIR)/src $(CURDIR)/srcw
	mkdir -p $(CURDIR)/src $(CURDIR)/srcw
	tar cf - expat/* | tar --strip-components=1 -C $(CURDIR)/src   -xf -
	tar cf - expat/* | tar --strip-components=1 -C $(CURDIR)/srcw -xf -
	sed -i -e "s,libexpat\.la,libexpatw.la," \
		-e "s,libexpat_la,libexpatw_la," \
		$$(find srcw -name Makefile.am)
	cd $(CURDIR)/src ; ./buildconf.sh
	cd $(CURDIR)/srcw; ./buildconf.sh
	touch $@

build/config.status: config-common-stamp
	dh_testdir
	(mkdir -p $(@D); cd $(@D); CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" LDFLAGS="$(LDFLAGS)" \
	 ../src/configure $(CONFFLAGS) --prefix=/usr --mandir=\$${prefix}/share/man --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH))

buildw/config.status: config-common-stamp
	dh_testdir
	(mkdir -p $(@D); cd $(@D); CFLAGS="$(CFLAGS) -DXML_UNICODE" CPPFLAGS="$(CPPFLAGS)" LDFLAGS="$(LDFLAGS)" \
	 ../srcw/configure $(CONFFLAGS) --prefix=/usr --mandir=\$${prefix}/share/man --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH))

clean:
	dh_testdir
	dh_testroot
	rm -rf src/ srcw/
	rm -rf build/ buildw/
	rm -rf debian/tmp/
	dh_autoreconf_clean
	dh_clean config-common-stamp build-stamp debian/xmlwf.1

build: build-stamp
build-arch: build-stamp
build-indep: build-stamp
build-stamp: build/config.status buildw/config.status
	dh_testdir
	$(MAKE) $(NJOBS) -C build/
	$(MAKE) $(NJOBS) -C buildw/lib all
#	docbook-to-man doc/xmlwf.sgml > debian/xmlwf.1
	echo "##### add testsuite ########################"
	$(MAKE) -C build/ check || ( cat build/tests/test-suite.log ; exit 1 )
	echo "##### end testsuite ########################"
	touch $@

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) -C build/ install DESTDIR=$(CURDIR)/debian/tmp
	$(MAKE) -C buildw/lib install DESTDIR=$(CURDIR)/debian/tmp APIHEADER=
	# Move libexpat.so.* to /lib so that zfsutils can use it.
	mkdir -p $(CURDIR)/debian/tmp/lib/$(DEB_HOST_MULTIARCH)
	mv $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libexpat.so.* \
		$(CURDIR)/debian/tmp/lib/$(DEB_HOST_MULTIARCH)/
	for i in $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libexpat.so ; do \
		dest=$$(readlink $$i) ; \
		rm -f $$i ; \
		ln -s /lib/$(DEB_HOST_MULTIARCH)/$$dest $$i ; \
	done
	mkdir -p debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/include/expat_config.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/.

binary-indep: build install
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_install -a --sourcedir=debian/tmp
	rm debian/libexpat1-dev/usr/share/doc/libexpat1-dev/expat.html/Makefile.am
	dh_installdocs -a
	dh_installman -a
#	dh_installman -pexpat debian/xmlwf.1
	dh_installexamples -a
	dh_installchangelogs -a expat/Changes
	dh_link -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	chmod 644 $(CURDIR)/debian/libexpat1-dev/usr/share/doc/libexpat1-dev/examples/* \
	          $(CURDIR)/debian/libexpat1-dev/usr/share/aclocal/*
	dh_makeshlibs -a -V --add-udeb=$(UPACKAGE)
	dh_installdeb -a
	dh_shlibdeps -a -l $(CURDIR)/debian/libexpat1/usr/lib/$(DEB_HOST_MULTIARCH)
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch

.PHONY: clean build install binary-indep binary-arch binary

## expat 2.2.6.2

=== debian/changelog ===
expat (2.2.6.2-2+dde) unstable; urgency=medium

  * fix CVE
    CVE-2022-25315 CVE-2022-25314 CVE-2022-25313
    CVE-2022-25236 CVE-2022-25235

 -- lishengyu <lishengyu@uniontech.com>  Tue, 22 Feb 2022 11:40:47 +0800

expat (2.2.6.1-2+dde) unstable; urgency=high

  * update to buster-security 2.2.6-2+deb10u2
  * lib: Detect and prevent troublesome left shifts in function storeAtts
    (CVE-2021-45960) (Closes: #1002994)
  * lib: Prevent integer overflow on m_groupSize in function doProlog
    (CVE-2021-46143)
  * lib: Prevent integer overflow at multiple places (CVE-2022-22822,
    CVE-2022-22823, CVE-2022-22824, CVE-2022-22825, CVE-2022-22826,
    CVE-2022-22827) (Closes: #1003474)
  * lib: Detect and prevent integer overflow in XML_GetBuffer (CVE-2022-23852)
  * lib: Prevent integer overflow in doProlog (CVE-2022-23990)

 -- Salvatore Bonaccorso <carnil@debian.org>  Wed, 09 Feb 2022 15:18:06 +0100

## expat 2.2.6.3

=== debian/changelog ===
expat (2.2.6.3-2+deepin) unstable; urgency=medium

  * fix CVE-2022-40674.
  * 

 -- yanghaibo <yanghaibo@uniontech.com>  Fri, 28 Oct 2022 09:28:17 +0800

## expat 2.2.7

=== expat/CMakeLists.txt ===
# This file is copyrighted under the BSD-license for buildsystem files of KDE
# copyright 2010, Patrick Spendrin <ps_ml@gmx.de>

project(expat)

cmake_minimum_required(VERSION 2.8.10)
set(PACKAGE_BUGREPORT "expat-bugs@libexpat.org")
set(PACKAGE_NAME "expat")
set(PACKAGE_VERSION "2.2.7")
set(PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")
set(PACKAGE_TARNAME "${PACKAGE_NAME}")

include(GNUInstallDirs)

if(WINCE)
    set(BUILD_tools_default OFF)
else()
    set(BUILD_tools_default ON)
endif()
if(MSVC OR NOT BUILD_tools_default)
    set(BUILD_doc_default OFF)
else()
    find_program(DOCBOOK_TO_MAN NAMES docbook2x-man db2x_docbook2man docbook2man docbook-to-man)
    if(DOCBOOK_TO_MAN)
        set(BUILD_doc_default ON)
    else()
        set(BUILD_doc_default OFF)
    endif()
endif()

option(BUILD_tools "build the xmlwf tool for expat library" ${BUILD_tools_default})
option(BUILD_examples "build the examples for expat library" ON)
option(BUILD_tests "build the tests for expat library" ON)
option(BUILD_shared "build a shared expat library" ON)
option(BUILD_doc "build man page for xmlwf" ${BUILD_doc_default})
option(USE_libbsd "utilize libbsd (for arc4random_buf)" OFF)
option(INSTALL "install expat files in cmake install target" ON)

if(USE_libbsd)
    find_library(LIB_BSD NAMES bsd)
    if(NOT LIB_BSD)
        message(FATAL_ERROR "USE_libbsd option is enabled, but libbsd was not found")
    else()
        set(HAVE_LIBBSD TRUE)
    endif()
endif()

# configuration options
set(XML_CONTEXT_BYTES 1024 CACHE STRING "Define to specify how much context to retain around the current parse point")
option(XML_DTD "Define to make parameter entity parsing functionality available" ON)
option(XML_NS "Define to make XML Namespaces functionality available" ON)
option(WARNINGS_AS_ERRORS "Treat all compiler warnings as errors" OFF)
if(NOT WIN32)
    option(XML_DEV_URANDOM "Define to include code reading entropy from `/dev/urandom'." ON)
    if(XML_DEV_URANDOM)
        set(XML_DEV_URANDOM 1)
    else(XML_DEV_URANDOM)
        set(XML_DEV_URANDOM 0)
    endif(XML_DEV_URANDOM)
endif()
option(XML_UNICODE "Use UTF-16 encoded chars (two bytes) instead of UTF-8" OFF)
option(XML_UNICODE_WCHAR_T "Use wchar_t to represent UTF-16 instead of unsigned short" OFF)

if(XML_DTD)
    set(XML_DTD 1)
else(XML_DTD)
    set(XML_DTD 0)
endif(XML_DTD)
if(XML_NS)
    set(XML_NS 1)
else(XML_NS)
    set(XML_NS 0)
endif(XML_NS)
if(XML_UNICODE)
    set(XML_UNICODE 1)
else(XML_UNICODE)
    set(XML_UNICODE 0)
endif(XML_UNICODE)
if(XML_UNICODE_WCHAR_T)
    set(XML_UNICODE_WCHAR_T 1)
else(XML_UNICODE_WCHAR_T)
    set(XML_UNICODE_WCHAR_T 0)
endif(XML_UNICODE_WCHAR_T)

if(XML_UNICODE_WCHAR_T AND NOT XML_UNICODE)
    message(SEND_ERROR "Option XML_UNICODE_WCHAR_T=ON may not be used without XML_UNICODE=ON.")
    set(XML_UNICODE 1)
endif(XML_UNICODE_WCHAR_T AND NOT XML_UNICODE)

if(BUILD_tools AND (XML_UNICODE AND NOT XML_UNICODE_WCHAR_T))
    message(SEND_ERROR "The xmlwf tool can not be built with option XML_UNICODE_WCHAR_T=OFF and XML_UNICODE=ON. Either set XML_UNICODE_WCHAR_T=ON or BUILD_tools=OFF.")
endif()

if(BUILD_tests)
    enable_testing()
endif(BUILD_tests)

include(${CMAKE_CURRENT_LIST_DIR}/ConfigureChecks.cmake)

set(EXTRA_COMPILE_FLAGS)
if(FLAG_NO_STRICT_ALIASING)
    set(EXTRA_COMPILE_FLAGS "${EXTRA_COMPILE_FLAGS} -fno-strict-aliasing")
endif()
if(FLAG_VISIBILITY)
  add_definitions(-DXML_ENABLE_VISIBILITY=1)
  set(EXTRA_COMPILE_FLAGS "${EXTRA_COMPILE_FLAGS} -fvisibility=hidden")
endif(FLAG_VISIBILITY)
if (WARNINGS_AS_ERRORS)
    if(MSVC)
        add_definitions(/WX)
    else(MSVC)
        set(EXTRA_COMPILE_FLAGS "${EXTRA_COMPILE_FLAGS} -Werror")
    endif(MSVC)
endif(WARNINGS_AS_ERRORS)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EXTRA_COMPILE_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EXTRA_COMPILE_FLAGS}")

set(MSVC_USE_STATIC_CRT OFF CACHE BOOL "Use /MT flag (static CRT) when compiling in MSVC")
if (MSVC)
    if (MSVC_USE_STATIC_CRT)
        message("-- Using static CRT ${MSVC_USE_STATIC_CRT}")
        foreach(flag_var
                CMAKE_CXX_FLAGS_DEBUG
                CMAKE_CXX_FLAGS_RELEASE
                CMAKE_CXX_FLAGS_MINSIZEREL
                CMAKE_CXX_FLAGS_RELWITHDEBINFO
                CMAKE_C_FLAGS_DEBUG
                CMAKE_C_FLAGS_RELEASE
                CMAKE_C_FLAGS_MINSIZEREL
                CMAKE_C_FLAGS_RELWITHDEBINFO
                )
            string(REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
        endforeach()
    endif()
endif()

include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/lib)
if(MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS -wd4996)
endif(MSVC)
if(WIN32)
    set(CMAKE_DEBUG_POSTFIX "d" CACHE STRING "Add a suffix, usually d on Windows")
endif(WIN32)

set(expat_SRCS
    lib/loadlibrary.c
    lib/xmlparse.c
    lib/xmlrole.c
    lib/xmltok.c
    lib/xmltok_impl.c
    lib/xmltok_ns.c
)

if(BUILD_shared)
    set(_SHARED SHARED)
    if(WIN32)
        set(expat_SRCS ${expat_SRCS} lib/libexpat.def)
    endif(WIN32)
else(BUILD_shared)
    set(_SHARED STATIC)
    if(WIN32)
        add_definitions(-DXML_STATIC)
    endif(WIN32)
endif(BUILD_shared)

add_library(expat ${_SHARED} ${expat_SRCS})
if(USE_libbsd)
    target_link_libraries(expat ${LIB_BSD})
endif()

set(LIBCURRENT 7)   # sync
set(LIBREVISION 9)  # with
set(LIBAGE 6)       # configure.ac!
math(EXPR LIBCURRENT_MINUS_AGE "${LIBCURRENT} - ${LIBAGE}")

if(NOT WIN32)
    set_property(TARGET expat PROPERTY VERSION ${LIBCURRENT_MINUS_AGE}.${LIBAGE}.${LIBREVISION})
    set_property(TARGET expat PROPERTY SOVERSION ${LIBCURRENT_MINUS_AGE})
    set_property(TARGET expat PROPERTY NO_SONAME ${NO_SONAME})
endif(NOT WIN32)

macro(expat_install)
    if(INSTALL)
        install(${ARGN})
    endif()
endmacro()

expat_install(TARGETS expat RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
                      LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
                      ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix "\${prefix}")
set(libdir "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
set(includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
configure_file(expat.pc.in ${CMAKE_CURRENT_BINARY_DIR}/expat.pc @ONLY)

expat_install(FILES lib/expat.h lib/expat_external.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
expat_install(FILES ${CMAKE_CURRENT_BINARY_DIR}/expat.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

if(BUILD_tools)
    set(xmlwf_SRCS
        xmlwf/xmlwf.c
        xmlwf/xmlfile.c
        xmlwf/codepage.c
        xmlwf/readfilemap.c
    )

    add_executable(xmlwf ${xmlwf_SRCS})
    set_property(TARGET xmlwf PROPERTY RUNTIME_OUTPUT_DIRECTORY xmlwf)
    target_link_libraries(xmlwf expat)
    expat_install(TARGETS xmlwf DESTINATION ${CMAKE_INSTALL_BINDIR})
    if(BUILD_doc)
        file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/doc)
        add_custom_command(TARGET expat PRE_BUILD COMMAND "${DOCBOOK_TO_MAN}" "${PROJECT_SOURCE_DIR}/doc/xmlwf.xml" && mv "XMLWF.1" "${PROJECT_BINARY_DIR}/doc/xmlwf.1")
        expat_install(FILES "${PROJECT_BINARY_DIR}/doc/xmlwf.1" DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
     endif()
endif()

if(BUILD_examples)
    add_executable(elements examples/elements.c)
    set_property(TARGET elements PROPERTY RUNTIME_OUTPUT_DIRECTORY examples)
    target_link_libraries(elements expat)

    add_executable(outline examples/outline.c)
    set_property(TARGET outline PROPERTY RUNTIME_OUTPUT_DIRECTORY examples)
    target_link_libraries(outline expat)
endif(BUILD_examples)

if(BUILD_tests)
    ## these are unittests that can be run on any platform
    add_executable(runtests tests/runtests.c tests/chardata.c tests/structdata.c tests/minicheck.c tests/memcheck.c)
    set_property(TARGET runtests PROPERTY RUNTIME_OUTPUT_DIRECTORY tests)
    target_link_libraries(runtests expat)
    add_test(runtests tests/runtests)

    add_executable(runtestspp tests/runtestspp.cpp tests/chardata.c tests/structdata.c tests/minicheck.c tests/memcheck.c)
    set_property(TARGET runtestspp PROPERTY RUNTIME_OUTPUT_DIRECTORY tests)
    target_link_libraries(runtestspp expat)
    add_test(runtestspp tests/runtestspp)
endif(BUILD_tests)

=== debian/changelog ===
expat (2.2.7-2) unstable; urgency=high

  * Fix CVE-2019-15903: deny internal entities closing the doctype
    (closes: #939394).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 04 Sep 2019 18:01:00 +0000

expat (2.2.7-1) unstable; urgency=medium

  * New upstream release.
  * Update libexpat1 symbols.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 13 Jul 2019 21:46:00 +0000

## expat 2.2.9

=== debian/changelog ===
expat (2.2.9-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:39:58 +0100

expat (2.2.9-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version to 4.4.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 28 Sep 2019 18:49:55 +0000

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,13 @@
 Source: expat
 Section: text
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Standards-Version: 4.1.2
+Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Standards-Version: 4.4.0
 Build-Depends: debhelper (>= 11), docbook-to-man, docbook2x,
  libbsd-dev [kfreebsd-amd64 kfreebsd-i386 hurd-i386]
 Homepage: https://libexpat.github.io/
-Vcs-Browser: http://svn.debian.org/wsvn/debian-xml-sgml/packages/expat/trunk/
-Vcs-Svn: svn://svn.debian.org/svn/debian-xml-sgml/packages/expat/trunk/
+#Vcs-Browser: http://svn.debian.org/wsvn/debian-xml-sgml/packages/expat/trunk/
+#Vcs-Svn: svn://svn.debian.org/svn/debian-xml-sgml/packages/expat/trunk/
 
 Package: libexpat1-dev
 Section: libdevel

=== debian/rules ===
--- 
+++ 
@@ -78,9 +78,6 @@
 	$(MAKE) $(NJOBS) -C build/
 	$(MAKE) $(NJOBS) -C buildw/lib all
 #	docbook-to-man doc/xmlwf.sgml > debian/xmlwf.1
-	echo "##### add testsuite ########################"
-	$(MAKE) -C build/ check || ( cat build/tests/test-suite.log ; exit 1 )
-	echo "##### end testsuite ########################"
 	touch $@
 
 install: build

## expat 2.2.10

=== debian/changelog ===
expat (2.2.10-2+deb11u3) bullseye-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * lib: Relax fix to CVE-2022-25236 with regard to RFC 3986 URI characters
  * tests: Cover relaxed fix to CVE-2022-25236
  * lib: Document namespace separator effect right in header <expat.h>
  * lib|doc: Add a note on namespace URI validation

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 10 Mar 2022 21:38:43 +0100

expat (2.2.10-2+deb11u2) bullseye-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Prevent stack exhaustion in build_model (CVE-2022-25313)
  * Prevent integer overflow in storeRawNames (CVE-2022-25315)
  * Prevent integer overflow in copyString (CVE-2022-25314)
  * lib: Fix (harmless) use of uninitialized memory
  * lib: Protect against malicious namespace declarations (CVE-2022-25236)
    (Closes: #1005895)
  * tests: Cover CVE-2022-25236
  * lib: Drop unused macro UTF8_GET_NAMING
  * lib: Add missing validation of encoding (CVE-2022-25235)
    (Closes: #1005894)
  * lib: Add comments to BT_LEAD* cases where encoding has already been
    validated
  * tests: Cover missing validation of encoding (CVE-2022-25235)
  * Fix build_model regression.
  * tests: Protect against nested element declaration model regressions

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 20 Feb 2022 17:08:18 +0100

expat (2.2.10-2+deb11u1) bullseye-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * lib: Detect and prevent troublesome left shifts in function storeAtts
    (CVE-2021-45960) (Closes: #1002994)
  * lib: Prevent integer overflow on m_groupSize in function doProlog
    (CVE-2021-46143)
  * lib: Prevent integer overflow at multiple places (CVE-2022-22822,
    CVE-2022-22823, CVE-2022-22824, CVE-2022-22825, CVE-2022-22826,
    CVE-2022-22827) (Closes: #1003474)
  * lib: Detect and prevent integer overflow in XML_GetBuffer (CVE-2022-23852)
  * tests: Cover integer overflow in XML_GetBuffer (CVE-2022-23852)
  * lib: Prevent integer overflow in doProlog (CVE-2022-23990)

 -- Salvatore Bonaccorso <carnil@debian.org>  Mon, 07 Feb 2022 22:26:48 +0100

expat (2.2.10-2) unstable; urgency=medium

  * Provide stage1 (bootstrap) build profile (closes: #896011).

  [ Matthias Klose <doko@ubuntu.com> ]
  * Don't build the udeb package when requested (closes: #983324).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 23 Feb 2021 17:54:13 +0100

expat (2.2.10-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version to 4.5.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 04 Oct 2020 07:39:41 +0200

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,11 @@
 Section: text
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Standards-Version: 4.4.0
-Build-Depends: debhelper (>= 11), docbook-to-man, docbook2x,
- libbsd-dev [kfreebsd-amd64 kfreebsd-i386 hurd-i386]
+Build-Depends: debhelper-compat (= 11), docbook-to-man,
+ docbook2x <!stage1>, libbsd-dev [kfreebsd-amd64 kfreebsd-i386 hurd-i386]
+Rules-Requires-Root: no
+Standards-Version: 4.5.0
 Homepage: https://libexpat.github.io/
-#Vcs-Browser: http://svn.debian.org/wsvn/debian-xml-sgml/packages/expat/trunk/
-#Vcs-Svn: svn://svn.debian.org/svn/debian-xml-sgml/packages/expat/trunk/
 
 Package: libexpat1-dev
 Section: libdevel
@@ -40,6 +39,7 @@
 
 Package: libexpat1-udeb
 XC-Package-Type: udeb
+Build-Profiles: <!noudeb>
 Section: debian-installer
 Priority: optional
 Architecture: any

=== debian/watch ===
version=3
http://sf.net/expat/expat-(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))

## expat 2.4.1

=== debian/changelog ===
expat (2.4.1-2ubuntu0.3) impish-security; urgency=medium

  * SECURITY UPDATE: Stack exhaustion
    - debian/patches/CVE-2022-25313.patch: prevent
      stack exhaustion in build_model in expat/lib/xmlparse.c.
    - debian/patches/fix-build_model-regression.patch: fix build_model
      regression in expat/lib/xmlparse.c.
    - debian/patches/protect-against-nested-element*: in expat/lib/xmlparse.
    - CVE-2022-25313
  * SECURITY UPDATE: Integer overflow
    - debian/patches/CVE-2022-25314.patch: prevent integer overflow in
      copyString in expat/lib/xmlparse.c.
    - CVE-2022-25314
  * SECURITY UPDATE: Integer overflow
    - debian/patches/CVE-2022-25315.patch: prevent integer overflow in
      storeRawNames in expat/lib/xmlparse.c.
    - CVE-2022-25315
  * SECURITY UPDATE: relax fix to CVE-2022-25236 with regard to
    RFC 3986 URI characters and possibly regressions
    - debian/patches/CVE-2022-25236-3.patch: add a note on namespace URI
      validation in expat/doc/reference.html, expat/lib/expat.h.
    - debian/patches/CVE-2022-25236-4.patch: document namespace separator
      effect right in header expat/lib/expat.h.
    - debian/patches/CVE-2022-25236-5.patch: cover relaxed fix in tests.
    - debian/patches/CVE-2022-25236-6.patch: relax fix with regard to
      RFC 3986 URI characters in expat/lib/xmlparse.c. (LP: #1963903)

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Mon, 21 Feb 2022 14:42:01 -0300

expat (2.4.1-2ubuntu0.1) impish-security; urgency=medium

  * SECURITY UPDATE: Realloc misbehavior
    - debian/patches/CVE-2021-45960.patch: detect and prevent troublesome
      left shifts in function storeAtts in expat/lib/xmlparse.c.
    - CVE-2021-45960
  * SECURITY UPDATE: Integer overflow
    - debian/patches/CVE-2021-46143.patch: prevent integer overflow
      on m_groupSize in function doProlog in expat/lib/xmlparse.c.
    - CVE-2021-46143
  * SECURITY UPDATE: Integer overflow
    - debian/patches/CVE-2022-22822-to-CVE-2022-22827.patch: prevent integer overflow
      in multiple places in expat/lib/xmlparse.c.
    - CVE-2022-22822
    - CVE-2022-22823
    - CVE-2022-22824
    - CVE-2022-22825
    - CVE-2022-22826
    - CVE-2022-22827
  * SECURITY UPDATE: Signed integer overflow
    - debian/patches/CVE-2022-23852-*.patch: detect and prevent
      integer overflow in XML_GetBuffer in expat/lib/xmlparse.c and
      adds test to cover it in expat/tests/runtests.c.
    - CVE-2022-23852
  * SECURITY UPDATE: Integer overflow
    - debian/patches/CVE-2022-23990.patch: prevent integer overflow in
      doProlog in expat/lib/xmlparse.c.
    - CVE-2022-23990
  * SECURITY UPDATE: Incomplete validation encoding
    - debian/patches/CVE-2022-25235-*.patch: adds missing validation
      and adds tests in expat/lib/xmltok_impl.c, expat/tests/runtests.c.
    - CVE-2022-25235
  * SECURITY UPDATE: Namespace-separator insertions
    - debian/patches/CVE-2022-25236-*.patch: Protect against malicious
      namespace declarations in expat/lib/xmlparse.c, expat/tests/runtests.c.
    - CVE-2022-25236

 -- Leonidas Da Silva Barbosa <leo.barbosa@canonical.com>  Thu, 17 Feb 2022 19:44:18 -0300

expat (2.4.1-2) unstable; urgency=medium

  * Upload to Sid.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 09 Sep 2021 21:26:21 +0200

expat (2.4.1-1) experimental; urgency=high

  * New upstream release:
    - fix CVE-2013-0340: protect against billion laughs attacks
      (denial-of-service; flavors targeting CPU time or RAM or both,
      leveraging general entities or parameter entities or both).
  * Update libexpat1 symbols.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 24 May 2021 10:14:11 +0200

expat (2.3.0-1) experimental; urgency=medium

  * New upstream release.
  * Update debhelper level to 13 .
  * Update Standards-Version to 4.5.1 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 10 May 2021 19:20:19 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: expat
 Section: text
 Priority: optional
-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Build-Depends: debhelper-compat (= 11), docbook-to-man,
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Build-Depends: debhelper-compat (= 13), docbook-to-man,
  docbook2x <!stage1>, libbsd-dev [kfreebsd-amd64 kfreebsd-i386 hurd-i386]
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://libexpat.github.io/
 
 Package: libexpat1-dev
@@ -38,7 +39,7 @@
  might find in the XML document (like start tags).
 
 Package: libexpat1-udeb
-XC-Package-Type: udeb
+Package-Type: udeb
 Build-Profiles: <!noudeb>
 Section: debian-installer
 Priority: optional

## expat 2.4.7

=== debian/changelog ===
expat (2.4.7-1ubuntu0.6) jammy-security; urgency=medium

  * SECURITY UPDATE: denial of service via stack overflow
    - debian/patches/CVE-2024-8176-pre.patch: Remove XML_DTD guards
      before is_param accesses
    - debian/patches/CVE-2024-8176-test-pre-1.patch: minicheck: Add
      fail_unless() macro
    - debian/patches/CVE-2024-8176-test-pre-2.patch: tests: Rename
      _fail_unless to _assert_true for clarity
    - debian/patches/CVE-2024-8176-test-pre-3.patch: minicheck: Add
      simple subtest support
    - debian/patches/CVE-2024-8176-1.patch: Resolve the recursion during
      entity processing to prevent stack overflow
    - debian/patches/CVE-2024-8176-2.patch: Stop updating event pointer
      on exit for reentry
    - CVE-2024-8176

 -- Vyom Yadav <vyom.yadav@canonical.com>  Mon, 07 Apr 2025 20:07:15 +0530

expat (2.4.7-1ubuntu0.5) jammy-security; urgency=medium

  * SECURITY UPDATE: denial-of-service via XML_ResumeParser                   
    - debian/patches/CVE-2024-50602-1.patch: Make function XML_StopParser of  
      expat/lib/xmlparse.c refuse to stop/suspend an unstarted parser         
    - debian/patches/CVE-2024-50602-2.patch: Add XML_PARSING case to parser   
      state in function XML_StopParser of expat/lib/xmlparse.c                
    - debian/patches/CVE-2024-50602-3.patch: Add tests for CVE-2024-50602 to  
      expat/tests/runtests.c                                                
    - CVE-2024-50602 

 -- Nicolas Campuzano Jimenez <nicolas.campuzano@canonical.com>  Sun, 01 Dec 2024 15:51:42 -0500

expat (2.4.7-1ubuntu0.4) jammy-security; urgency=medium

  * SECURITY UPDATE: invalid input length
    - CVE-2024-45490-*.patch: adds a check to the XML_ParseBuffer function of
      expat/lib/xmlparse.c to identify and error out if a negative length is
      provided.
    - CVE-2024-45490
  * SECURITY UPDATE: integer overflow
    - CVE-2024-45491.patch: adds a check to the dtdCopy function of
      expat/lib/xmlparse.c to detect and prevent an integer overflow.
    - CVE-2024-45491
  * SECURITY UPDATE: integer overflow
    - CVE-2024-45492.patch: adds a check to the nextScaffoldPart function of
      expat/lib/xmlparse.c to detect and prevent an integer overflow.
    - CVE-2024-45492

 -- Ian Constantin <ian.constantin@canonical.com>  Tue, 10 Sep 2024 13:17:45 +0300

expat (2.4.7-1ubuntu0.3) jammy-security; urgency=medium

  * SECURITY UPDATE: denial-of-service
    - debian/patches/CVE-2023-52425.patch: Speed up parsing of big tokens.
    - CVE-2023-52425
  * SECURITY UPDATE: denial-of-service
    - debian/patches/CVE-2024-28757.patch: Detect billion laughs attack with
      isolated external parser.
    - CVE-2024-28757

 -- Fabian Toepfer <fabian.toepfer@canonical.com>  Wed, 13 Mar 2024 14:28:54 +0100

expat (2.4.7-1ubuntu0.2) jammy-security; urgency=medium

  * SECURITY UPDATE: use-after-free
    - debian/patches/CVE-2022-43680-1.patch: adds tests to cover
      DTD destruction in XML_ExternalEntityParserCreate in
      expat/tests/runtests.c.
    - debian/patches/CVE-2022-43680-2.patch: fix overeager DTD
      destruction in XML_ExternalEntityParserCreate in
      expat/lib/xmlparse.c.
    - CVE-2022-43680

 -- David Fernandez Gonzalez <david.fernandezgonzalez@canonical.com>  Fri, 18 Nov 2022 12:21:42 +0100

expat (2.4.7-1ubuntu0.1) jammy-security; urgency=medium

  * SECURITY UPDATE: Use-after-free in doContent
    - debian/patches/CVE-2022-40674.patch: ensure storeRawNames()
      is always called in func internalEntityProcessor if handling
      unbalanced tags in expat/lib/xmlparse.c.
    - CVE-2022-40674

 -- David Fernandez Gonzalez <david.fernandezgonzalez@canonical.com>  Tue, 15 Nov 2022 16:01:53 +0100

expat (2.4.7-1) unstable; urgency=medium

  * New upstream release:
    - relax fix to CVE-2022-25236 with regard to all valid URI characters
      (RFC 3986).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 05 Mar 2022 07:11:48 +0100

expat (2.4.6-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 21 Feb 2022 21:08:18 +0100

expat (2.4.5-2) unstable; urgency=medium

  * Fix build_model regression (closes: #1006162).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 20 Feb 2022 16:26:07 +0100

expat (2.4.5-1) unstable; urgency=high

  * New upstream release:
    - fixes CVE-2022-25235: certain validation of encoding, such as checks
      for whether a UTF-8 character is valid can cause code execution
      (closes: #1005894),
    - fixes CVE-2022-25236: passing namespace separator characters can cause
      code execution (closes: #1005895),
    - fixes CVE-2022-25313: an attacker can trigger stack exhaustion in
      build_model via a large nesting depth in the DTD element,
    - fixes CVE-2022-25314: integer overflow in function copyString() ,
    - fixes CVE-2022-25315: integer overflow in function storeRawNames() .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 19 Feb 2022 07:34:25 +0100

expat (2.4.4-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 01 Feb 2022 18:51:12 +0100

expat (2.4.3-3) unstable; urgency=high

  * Backport security fix for CVE-2022-23990: integer overflow in
    doProlog() .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 27 Jan 2022 06:44:50 +0100

expat (2.4.3-2) unstable; urgency=high

  * Backport security fix for CVE-2022-23852: XML_GetBuffer() signed integer
    overflow.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 24 Jan 2022 18:18:59 +0100

expat (2.4.3-1) unstable; urgency=high

  * New upstream release:
    - fixes CVE-2021-45960: left shifts by >=29 places resulting in realloc
      acting as free, realloc allocating too few bytes, undefined behavior
      depending on architecture,
    - fixes CVE-2021-46143: integer overflow leading to realloc acting
      as free,
    - fixes CVE-2022-22822: integer overflow in function addBinding,


=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper-compat (= 13), docbook-to-man,
  docbook2x <!stage1>, libbsd-dev [kfreebsd-amd64 kfreebsd-i386 hurd-i386]
 Rules-Requires-Root: no
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://libexpat.github.io/
 
 Package: libexpat1-dev
@@ -28,7 +28,6 @@
 Package: libexpat1
 Section: libs
 Architecture: any
-Conflicts: wink (<= 1.5.1060-4)
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}

## expat 2.4.7-1+11.0trisquel0

=== debian/changelog ===
expat (2.4.7-1+11.0trisquel0) aramo; urgency=medium

  * Fetch and build as udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Tue, 01 Nov 2022 15:16:52 +0000

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: expat
 Section: text
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 Build-Depends: debhelper-compat (= 13), docbook-to-man,
  docbook2x <!stage1>, libbsd-dev [kfreebsd-amd64 kfreebsd-i386 hurd-i386]
 Rules-Requires-Root: no

## expat 2.4.7-1+11.0trisquel5

=== debian/changelog ===
expat (2.4.7-1+11.0trisquel5) aramo-security; urgency=medium

  * Fetch and build as udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Tue, 08 Apr 2025 23:37:28 +0000

=== debian/control ===
--- 
+++ 
@@ -2,6 +2,7 @@
 Section: text
 Priority: optional
 Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
+XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends: debhelper-compat (= 13), docbook-to-man,
  docbook2x <!stage1>, libbsd-dev [kfreebsd-amd64 kfreebsd-i386 hurd-i386]
 Rules-Requires-Root: no

## expat 2.4.8

=== debian/changelog ===
expat (2.4.8-2ubuntu0.22.10.1) kinetic-security; urgency=medium

  * SECURITY UPDATE: use-after-free
    - debian/patches/CVE-2022-43680-1.patch: adds tests to cover
      DTD destruction in XML_ExternalEntityParserCreate in
      expat/tests/runtests.c.
    - debian/patches/CVE-2022-43680-2.patch: fix overeager DTD
      destruction in XML_ExternalEntityParserCreate in
      expat/lib/xmlparse.c.
    - CVE-2022-43680

 -- David Fernandez Gonzalez <david.fernandezgonzalez@canonical.com>  Fri, 18 Nov 2022 12:22:47 +0100

expat (2.4.8-2) unstable; urgency=high

  * Backport security fix for CVE-2022-40674: heap use-after-free issue in
    doContent() (closes: #1019761).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 15 Sep 2022 20:53:15 +0200

expat (2.4.8-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 29 Mar 2022 22:01:08 +0200
